;-------------------------------------------------------------------------------
;[`
sound_init
	lda	#$1f
	sta	$4015
	lda	#$00
	sta	<$a0
	sta	<$a2
	sta	<$a4
	sta	<$a6
	sta	<$70
	sta	<$72
	sta	<$74
	sta	<$76
	sta	$4011

	lda	#$01
	sta	<$c0
	sta	<$c2
	sta	<$c4
	sta	<$c6
	sta	<$c8

	ldy	#$00
sound_channel_set:
	lda	<$f0			;
	cmp	#$05			;
	beq	return4			;`lȏȂI
	asl	a
	tax				;2{xɊi[
	lda	sound_data_table,x
	sta	<$e0,x			;f[^Jnʒu
	inx
	lda	sound_data_table,x
	sta	<$e0,x			;f[^Jnʒu
	inc	<$f0
	jmp	sound_channel_set
return4
	lda	#$00
	sta	<$f0
	rts
;-------------------------------------------------------------------------------
sound_driver_start:

	lda	<$f0
	cmp	#$05
	beq	sound_channel_reset	;$f005Ȃ炨I

	asl	a
	tax
	dec	<$c0,x			;JE^炵
	bne	return1			;[ȊOȂJE^炵ĂI

	lda	<$f0			;DPCM part
	cmp	#$04			;
	beq	sound_dpcm_part		;

	jsr	sound_data_read		;[ȂTEhǂݍ

	lda	<$70,x
	and	#%00000100
	cmp	#%00000100
	bne	enve_write
	jsr	sound_duty_enverope	;iHjF`

enve_write:
	lda	<$70,x
	and	#%00000001
	cmp	#%00000001
	bne	freq_write
	jsr	sound_software_enverope	;Gx[v`

freq_write:
	jsr	sound_data_write	;ăf[^o
	inc	<$f0			;̃`lݒ肵
	jmp	sound_driver_start	;͂߂ɖ߂

return1:
	lda	<$70,x
	and	#%00000100
	cmp	#%00000100
	bne	enve_write2
	jsr	sound_duty_enverope	;쉹F`

enve_write2:
	lda	<$70,x
	and	#%00000001
	cmp	#%00000001
	bne	lfo_write
	jsr	sound_software_enverope

lfo_write:
	lda	<$70,x
	and	#%00010000
	cmp	#%00010000
	bne	pitchenve_write
	jsr	sound_lfo

pitchenve_write:
	lda	<$70,x
	and	#%00000010
	cmp	#%00000010
	bne	return7
	jsr	sound_pitch_enverope
	jmp	return7

sound_dpcm_part:
	jsr	sound_dpcm_play
return7:
	inc	<$f0			;̃`lݒ肵
	jmp	sound_driver_start	;͂߂ɖ߂

sound_channel_reset:
	lda	#$00
	sta	<$f0
	rts				;łI
;-------------------------------------------------------------------------------
frequency_set:

	lda	<$f0
	asl	a
	tax
	lda	<$B0,x			;Kf[^ǂݏo
	and	#%00001111		;4bito
	asl	a
	tay

	lda	<$f0
	cmp	#$03
	beq	noise_frequency_get	;S`lڂȂmCYg擾

	lda	psg_frequency_table,y	;PSGge[uLowǂݏo
	sta	<$D1,x			;
	iny				;yP₵
	lda	psg_frequency_table,y	;PSGge[uHighǂݏo
	sta	<$D0,x			;

oct_set1:

	lda	<$B0,x			;Kf[^ǂݏo
	lsr	a			;4bito
	lsr	a			;
	lsr	a			;
	lsr	a			;
	beq	freq_end		;[Ȃ炻̂܂܏I
	tay				;

oct_set2:

	lsr	<$D0,x			;IN^[uݒ
	ror	<$D1,x			;IN^[uݒ
	dey				;
	bne	oct_set2		;IN^[uJԂ

freq_end:
	lda	<$70,x
	and	#%10000000
	cmp	#%10000000
	beq	detune_part
	rts

detune_part:
	lda	<$90,x
	and	#%10000000
	cmp	#%10000000
	beq	detune_plus

detune_minus:
	lda	<$90,x
	adc	<$d1,x
	sta	<$d1,x
	rts

detune_plus:
	lda	<$90,x
	and	#%01111111
	sta	<$ff
	lda	<$d1,x
	sbc	<$ff
	sta	<$d1,x
	rts

noise_frequency_get:
	lda	noise_frequency_table,y	;ge[uLowǂݏo
	sta	<$D1,x			;
	iny				;yP₵
	lda	noise_frequency_table,y	;ge[uHighǂݏo
	sta	<$D0,x			;
	rts
;-------------------------------------------------------------------------------
sound_data_read:
	jsr	reg400x

;\tgEFAGx[vǂݍ݃AhX
	lda	<$80,x
	asl	a
	tay
	lda	softenve_table,y
	sta	<$60,x
	iny
	lda	softenve_table,y
	sta	<$61,x

;sb`Gx[vǂݍ݃AhX
	lda	<$91,x
	asl	a
	tay
	lda	pitchenve_table,y
	sta	<$f1,x
	iny
	lda	pitchenve_table,y
	sta	<$f2,x

;f[eBGx[vǂݍ݃AhX
	lda	<$10,x
	asl	a
	tay
	lda	dutyenve_table,y
	sta	<$00,x
	iny
	lda	dutyenve_table,y
	sta	<$01,x

;\tgEFALFO
	lda	<$a0,x			;LFOJnJE^Zbg
	sta	<$c1,x

	lda	<$70,x			;LFOJnZbg
	and	#%11011111
	sta	<$70,x
	and	#%01000000
	lsr	a
	ora	<$70,x
	sta	<$70,x
	lda	<$20,x
	lsr	a
	sta	<$40,x			;LFOύXJE^Zbg

	jsr	reg400x
	lda	[$e0,x]			;f[^ǂݍ
;----------
;f[^Ghݒ
	cmp	#$FF			;f[^$FFȂJԂƂ
	bne	duty_set		;ꂾƃYFȂ
					;Aʂɂ܂Ȃ
	lda	loop_point_table,x
	sta	<$e0,x			;[vJnʒu Low
	inx
	lda	loop_point_table,x
	sta	<$e0,x			;[vJnʒu High
	jmp	sound_data_read
;----------
;Fݒ
duty_set:
	cmp	#$fe
	bne	volume_set
	jsr	sound_data_address
	lda	[$e0,x]			;Ff[^ǂݏo
	pha
	and	#%10000000		;8bitڊmF
	cmp	#%10000000
	bne	duty_enverope_part	;iHjF

duty_select_part:
	lda	<$70,x
	and	#%11111011
	sta	<$70,x			;f[eBGx[vw
	jsr	reg400x
	pla
	asl	a
	asl	a
	asl	a
	asl	a
	sta	<$50,x			;
	ora	<$51,x
	sta	$4000,y
	jsr	sound_data_address
	jmp	sound_data_read

duty_enverope_part:
	lda	<$70,x
	ora	#%00000100
	sta	<$70,x			;f[eBGx[vLw
	pla
	sta	<$10,x
	asl	a
	tay
	lda	dutyenve_table,y	;f[eBGx[vAhXݒ
	sta	<$00,x			;
	iny				;
	lda	dutyenve_table,y	;
	sta	<$01,x			;
	jsr	sound_data_address
	jmp	sound_data_read

;----------
;ʐݒ
volume_set:
	cmp	#$fd
	bne	lfo_set
	jsr	sound_data_address
	lda	[$e0,x]			;
	pha
	and	#%10000000		;8bitڊmF
	cmp	#%10000000
	bne	softenve_part		;\tgGx

volume_part:
	lda	<$70,x
	and	#%11111110
	ora	#%00000010		;Ԃ悭킩񂪔ÔߓƂ
	sta	<$70,x			;\tgGxw

	pla
	and	#%00001111
	sta	<$51,x
	ora	<$50,x
	sta	$4000,y			;{[
	jsr	sound_data_address
	jmp	sound_data_read

softenve_part:
	lda	<$70,x
	ora	#%00000001
	sta	<$70,x			;\tgGxLw

	pla
	sta	<$80,x
	asl	a
	tay
	lda	softenve_table,y	;\tgGxf[^AhXݒ
	sta	<$60,x			;
	iny				;
	lda	softenve_table,y	;
	sta	<$61,x			;
	jsr	sound_data_address
	jmp	sound_data_read

;----------
lfo_set:
	cmp	#$fb
	bne	detune_set

	jsr	sound_data_address
	lda	[$e0,x]
	cmp	#$ff
	bne	lfo_data_set

	jsr	reg400x
	lda	<$70,x
	and	#%10001111		;LFO
	sta	<$70,x
	jsr	sound_data_address
	jmp	sound_data_read

lfo_data_set:
	asl	a
	asl	a
	tay

	lda	<$f0
	asl	a
	tax

	lda	lfo_data,y
	sta	<$a0,x
	sta	<$c1,x			;LFOJn܂ł̃JE^Zbg
	iny
	lda	lfo_data,y
	sta	<$30,x			;LFOœʃZbg
	iny
	lda	lfo_data,y
	sta	<$20,x			;g`]܂ł̓񐔃Zbg
	inc	<$20,x
	iny
	lda	<$70,x
	and	#%10001111
	ora	#%00010000		;LFOLtOZbg
	ora	lfo_data,y		;LFOJntOZbg
	sta	<$70,x

	jsr	sound_data_address
	jmp	sound_data_read

	
;----------
detune_set:
	cmp	#$fa
	bne	sweep_set
	jsr	sound_data_address
	lda	[$e0,x]
	cmp	#$ff
	bne	detune_data_set

	jsr	reg400x
	lda	<$70,x
	and	#%01111111		;detune
	sta	<$70,x
	jsr	sound_data_address
	jmp	sound_data_read

detune_data_set:
	pha
	jsr	reg400x
	pla
	tay
	sta	<$90,x
	lda	<$70,x
	ora	#%10000000		;detuneL
	sta	<$70,x
	jsr	sound_data_address
	jmp	sound_data_read

;----------
sweep_set:
	cmp	#$f9
	bne	pitch_set

	jsr	sound_data_address
	lda	[$e0,x]
	sta	$4001,y
	jsr	sound_data_address
	jmp	sound_data_read
;----------
;sb`Gx[vݒ
pitch_set:
	cmp	#$f8
	bne	oto_set
	jsr	sound_data_address
	lda	[$e0,x]
	cmp	#$ff
	bne	pitch_enverope_part

	lda	<$70,x
	and	#%11111101
	sta	<$70,x
	jsr	sound_data_address
	jmp	sound_data_read

pitch_enverope_part:
	sta	<$91,x
	asl	a
	tay
	lda	pitchenve_table,y
	sta	<$f1,x
	iny
	lda	pitchenve_table,y
	sta	<$f2,x

	lda	<$70,x
	ora	#%00000010
	sta	<$70,x

	jsr	sound_data_address
	jmp	sound_data_read

;----------
oto_set:
	sta	<$B0,x			;͂܂
	jsr	sound_data_address
	lda	[$e0,x]			;ǂݏo
	sta	<$C0,x			;ۂ̃JEglƂȂ܂
	jsr	sound_data_address
	jsr	frequency_set		;gZbg
	rts

sound_data_address:
	inc	<$e0,x			;f[^AhX{P
	bne	return2			;ʂオ
	inc	<$e1,x			;f[^AhXS̈ʁij{P
return2:
	rts
;-------------------------------------------------------------------------------
sound_data_write:
	jsr	reg400x
	lda	<$f0
	cmp	#$03
	beq	noise_cut

write:
	lda	<$d1,x			;Low Write
	sta	$4002,y
	lda	<$d0,x			;High Write
	sta	$4003,y
	rts

noise_cut:
	lda	<$b0,x
	cmp	#$fc			;mCYŋxȂ΂
	bne	write			;
	rts
;-------------------------------------------------------------------------------
sound_software_enverope:
	jsr	reg400x
	lda	<$b0,x
	cmp	#$fc
	beq	return9

	lda	<$f0
	cmp	#$02
	beq	return6			;OpgȂ΂`

	lda	[$60,x]			;Gx[vf[^ǂݍ
	cmp	#$ff			;Ōォǁ[
	beq	return3			;ŌȂ烋[v

	sta	<$51,x
	ora	<$50,x			;Ff[^i4bitjƉ4bitőZ
	sta	$4000,y			;݁`
	jsr	enverope_address	;AhX₵
	rts				;܂
return9:
	lda	<$50,x
	sta	$4000,y			;{[[̏
	rts
return3:
	lda	<$80,x
	asl	a
	tay
	lda	softenve_lp_table,y
	sta	<$60,x
	iny
	lda	softenve_lp_table,y
	sta	<$61,x
return6:
	rts

;-------------------------------------------------------------------------------
enverope_address:
	inc	<$60,x
	bne	return5
	inc	<$61,x
return5:
	rts
;--------------------------------------	
reg400x:
	lda	<$f0
	asl	a
	tax
	asl	a
	tay
	rts
;-------------------------------------------------------------------------------
sound_duty_enverope:
	jsr	reg400x

	lda	<$f0
	cmp	#$02
	beq	return21		;OpgȂ΂`

	lda	[$00,x]			;Gx[vf[^ǂݍ
	cmp	#$ff			;Ōォǁ[
	beq	return22		;ŌȂ炻̂܂܂܂
	asl	a
	asl	a
	asl	a
	asl	a
	sta	<$50,x
	ora	<$51,x			;Ff[^i4bitjƉ4bitőZ
	sta	$4000,y			;݁`
	jsr	duty_enverope_address	;AhX₵
	rts				;܂

return22:
	lda	<$10,x
	asl	a
	tay
	lda	dutyenve_lp_table,y
	sta	<$00,x
	iny
	lda	dutyenve_lp_table,y
	sta	<$01,x
return21:
	rts

;-------------------------------------------------------------------------------
duty_enverope_address:
	inc	<$00,x
	bne	return23
	inc	<$01,x
return23:
	rts
;--------------------------------------	
sound_dpcm_play:
	jsr	reg400x
	lda	[$e0,x]			;f[^ǂݍ
;----------
	cmp	#$ff			;
	bne	no_dpcm			;
	lda	loop_point_table,x
	sta	<$e0,x			;[vJnʒu Low
	inx
	lda	loop_point_table,x
	sta	<$e0,x			;[vJnʒu High
	jmp	sound_dpcm_play
;----------
no_dpcm:
	cmp	#$fc

	bne	dpcm_set
	lda	#$00
	sta	$4011
	jmp	ontyou2

dpcm_set:
	asl	a
	asl	a
	tax

	pha
	lda	#$0F		;
	sta	$4015		;SoundChannel Reg.
	pla

	lda	dpcm_data,x		;DPCM control
	sta	$4010
	inx	
	lda	dpcm_data,x		;DPCM wave control
	sta	$4011
	inx	
	lda	dpcm_data,x		;DPCM address set
	sta	$4012
	inx	
	lda	dpcm_data,x		;DPCM length set
	sta	$4013

	lda	#$1F		;
	sta	$4015		;SoundChannel Reg.

ontyou2:
	jsr	reg400x
	jsr	sound_data_address
	lda	[$e0,x]			;ǂݏo
	sta	<$C0,x			;ۂ̃JEglƂȂ܂

	jsr	sound_data_address
	rts
;-------------------------------------------------------------------------------
sound_lfo:
;0x0c1 = COUNTER
;0x040 = 0		;LFOύXJE^ = 0
;0x070 = %xx10xxxx	;LFOtO=~

	jsr	reg400x
	dec	<$c1,x
	bne	lfo_end

	inc	<$c1,x

	lda	<$40,x
	cmp	<$20,x
	bne	tsuduki			;@@ALFOύXJE^ >= g`]܂ł̓񐔁@ȂA

	lda	#$00
	sta	<$40,x			;@@@@LFOύXJE^ = - g`]܂ł̓
	lda	<$70,x
	and	#%00100000
	cmp	#%00100000
	beq	jousyou			;@@@@ALFOtO = ~ȂA

kakou:
	lda	<$70,x
	adc	#$20
	sta	<$70,x			;@@@@@@LFOtO = ~
	jmp	tsuduki

jousyou:
	lda	<$70,x			;@@@@łȂȂiLFOtO = ~jȂA
	sbc	#$20
	sta	<$70,x			;@@@@@@LFOtO = ㏸


tsuduki:
	lda	<$70,x			;   LFOtO = ~ Ȃ
	and	#%00100000
	cmp	#%00100000
	beq	MINUS
					;ݐϒl = ݐϒl + P񂲂Ƃɑl
					;݂̒l = Kigj + ݐϒl
					;݂̒l = Kigj + (ݐϒl >> 4)
PLUS:
	lda	<$d1,x
	adc	<$30,x
	sta	<$d1,x			;    ݂̒l = ݂̒l - œl
	jmp	tsuduki2
MINUS:
	lda	<$d1,x			;  łȂȂiLFOtO = ㏸łȂj
	sbc	<$30,x
	sta	<$d1,x			;    ݂̒l = ݂̒l + œl
					;܂ŁB
tsuduki2:
	inc	<$40,x			;	@@LFOύXJE^ = LFOύXJE^ + 1
	jsr	reg400x
	lda	<$d1,x
	sta	$4002,y			;@@ݒlWX^ɃZbg
lfo_end:
	rts				;܂
;-------------------------------------------------------------------------------
sound_pitch_enverope:
	jsr	reg400x
	lda	[$f1,x]	
	pha
	cmp	#$ff
	beq	return62

	and	#%10000000
	cmp	#%10000000
	beq	pitch_plus

	pla
	adc	<$d1,x
	sta	<$d1,x
	jmp	pitch_write

pitch_plus:
	pla
	and	#%01111111
	sta	<$ff
	lda	<$d1,x
	sbc	<$ff
	sta	<$d1,x

pitch_write:
;	lda	<$d1,x
	sta	$4002,y			;݁`
	jsr	pitch_enverope_address	;AhX₵
	rts				;܂

return62:
	pla
	lda	<$91,x
	asl	a
	tay
	lda	pitchenve_lp_table,y
	sta	<$f1,x
	iny
	lda	pitchenve_lp_table,y
	sta	<$f2,x
	rts
;-------------------------------------------------------------------------------
pitch_enverope_address:
	inc	<$f1,x
	bne	return63
	inc	<$f2,x
return63:
	rts
;-------------------------------------------------------------------------------
